/*----------------------------------------------------------------------------*/
/* Programa para a construcao de arvores binarias perfeitamente balanceadas   */
/* Adaptado de Wirth, Algorimos e estruturas de dados                         */
/*----------------------------------------------------------------------------*/

#include <math.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>

typedef struct No* ptr;

struct No {
        char chave;
        ptr esquerda;
        ptr direita;
};

/*----------------------------------------------------------------------------*/
/* Funcao de montagem da arvore                                               */
/*----------------------------------------------------------------------------*/

ptr Arvore (int n) {
        ptr novono;
        char x, str[10];
        int nesq,ndir;

        if (n == 0) return NULL;

        nesq = (int) floor(n / 2);
        ndir = n - nesq - 1;
        printf("Informe o valor do no: ");
        gets(str);

        sscanf(str,"%c",&x);

        novono = (ptr) malloc(sizeof(struct No));

        novono->chave = x;
        novono->esquerda = Arvore(nesq);
        novono->direita  = Arvore(ndir);

        return novono;
}

/*----------------------------------------------------------------------------*/
/* Funcao de impressao da arvore                                              */
/*----------------------------------------------------------------------------*/

void ImprimeArvore (ptr t, int h) {
        int i;

        if (t) {

                ImprimeArvore(t->esquerda,h+1);
                for (i=0;i<h;i++) printf(" ");
                printf("%c\n",t->chave);
                ImprimeArvore(t->direita,h+1);
        }
}

/*----------------------------------------------------------------------------*/
/*                                Funcao principal                            */
/*----------------------------------------------------------------------------*/

void main() {
        int N;
        ptr Raiz;
        char str[10];

        clrscr();
        printf("Indique o numero de nos a ler (0=fim): ");

        gets(str);
        sscanf(str,"%d",&N);

        if (N > 0) {
                Raiz = Arvore(N);
                ImprimeArvore(Raiz,0);
        }
}


